/* An object containing a counter and a main method that starts 10 threads.
 * Each of these threads will then read the counter, increment the local copy,
 * sleep for 100 milliseconds. Then the thread prints HelloWorld and the 
 * threads value of the counter. With race conditions the same value may appear
 * multiple times, without race conditions, each value should only appear once. 
 */
object MUTS_Demo_noTM {
  var counter = 0
  def main(args: Array[String]): Unit = {
    for(i <- 1 to 10)
      new DemoThread_noTM().start()
    
  }
}

/* A class extending Thread. This version has no protection against race 
 * conditions. As a result is will not print out the correct result.
 */
class DemoThread_noTM extends Thread {
  override def run():Unit = {
    var counter = MUTS_Demo_noTM.counter
    counter += 1
    Thread.sleep(100)
    MUTS_Demo_noTM.counter = counter
    println("Hello World " + counter)
  }
}